'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UIColFix = function UIColFix(customEl) {
    _classCallCheck(this, UIColFix);

    //var element = this.el || document.querySelector(".ui-colfix");
    this.element = document.querySelector(customEl);
    //element.insertAdjacentHTML('afterend', '</div">');
    //element.parentElement.classList.add("wrap-ui-colfix");
    //element.parentElement.className += "wrap-ui-colfix";
    //var wrapEl = document.querySelector(".wrap-ui-colfix");

    var fixTo = this.element.getAttribute('data-fixto');
    var wrapEl = document.querySelector(fixTo) || this.element.parentElement;
    //references
    wrapEl.insertAdjacentHTML('afterbegin', '<div class="ref-top"><div/>');
    wrapEl.insertAdjacentHTML('beforeend', '<div class="ref-bottom" style="position:absolute; bottom:0px;"><div/>');
    //var prev = document.querySelector(".ref-top");
    //var next = document.querySelector(".ref-bottom");
    var prev = wrapEl.querySelector(".ref-top");
    var next = wrapEl.querySelector(".ref-bottom");
    var previous = window.scrollY || 0;

    var elementDistance = function elementDistance() {

        var body = document.body,
            html = document.documentElement;

        var height = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);

        var DSup = prev.getBoundingClientRect().top;
        var DInf = next.getBoundingClientRect().top;
        var ElmH = this.element.offsetHeight;
        var DocS = window.pageYOffset;
        var DocH = height;
        console.log("DSup : " + DSup);
        console.log("DInf : " + DInf);
        console.log("ElmH : " + ElmH);
        console.log("DocS : " + DocS);
        console.log("DocH : " + DocH);

        if (DSup < 0) {
            // element.style = '';
            //element.style = "";
            this.element.setAttribute('style', 'top:0; margin-left:0; position: fixed !important;');
            //element.style.top = '0';
            //element.classList.add('ui-colfixed');
            //element.classList.remove('ui-colabsoluted');
        }

        if (DInf <= ElmH) {
            //element.style.top = '';
            //element.classList.remove('ui-colfixed');
            //element.classList.add('ui-colabsoluted');
            //element.style = '';
            this.element.setAttribute('style', 'bottom: 0; position: absolute !important; top: auto !important;');
        }

        if (DSup >= 0) {
            //element.style.top = '';
            //element.classList.remove('ui-colfixed');
            //element.classList.remove('ui-colabsoluted');
            //element.style = '';
            this.element.setAttribute('style', '');
        }
    };

    elementDistance();

    setTimeout(function() {

        window.onscroll = function() {
            elementDistance();
        };
    }, 300);
};

exports.default = UIColFix;